<?php
    class Brand extends Controller{
		
        
        public function add()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            
            
            //start Add Anew Data
			if(isset($_POST['add']))
            {
                
                // preparing validation array
                $validationArray = array(
                                            "id_category"=>array(
                                                             "value"=>$this->loadSecurity($_POST['id_category'])->clear(),
                                                             "errorName"=>"Category",
                                                             "rules"=>"required|number"
                                                          ),
                                            "name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['enName'])->clear(),
                                                             "errorName"=>"Brand Name",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "ar_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['arName'])->clear(),
                                                             "errorName"=>"اسم الماركة",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "description"=>array(
                                                             "value"=>$this->loadSecurity($_POST['en_description'])->clear(),
                                                             "errorName"=>"Brand Description",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "ar_description"=>array(
                                                             "value"=>$this->loadSecurity($_POST['ar_description'])->clear(),
                                                             "errorName"=>"وصف الماركة",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "keywords"=>array(
                                                             "value"=>$this->loadSecurity($_POST['en_keywords'])->clear(),
                                                             "errorName"=>"Brand keywords",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "ar_keywords"=>array(
                                                             "value"=>$this->loadSecurity($_POST['ar_keywords'])->clear(),
                                                             "errorName"=>"الكلمات الدليلية",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "status"=>array(
                                                             "value"=>$this->loadSecurity($_POST['status'])->clear(),
                                                             "errorName"=>"Status",
                                                             "rules"=>"number"
                                                          ),
                                  );
                // load validation classs and pass validation data
                $dataValid = $this->loadValidation($validationArray)->formValidate();
                // check if the data is ok
                if(is_array($dataValid) && array_key_exists("success",$dataValid))
                {
                    // start upload image
                    $upload = $this->loadUpload("image")->do_upload();
                    
                    //if there is no errors
                    if (!array_key_exists('uploadError', $upload)) 
                    {
                       // prepare data
                        $dataModel['created_by'] = $user_id;
                        $dataModel['last_update_by'] = $user_id;
                        $dataModel['id_category'] = $dataValid['success']['id_category'];
                        $dataModel['status'] = $dataValid['success']['status'];
                        $dataModel['image'] = $upload['uploaded'][0];
                        $dataModel['created'] = time();
                        
                        $add = $this->loadModel("BrandModel",$dataModel)->add();
                        if(FALSE !== $add)
                        {
                            // add data to report
                            $repoatDataModel['id_brand'] = $add;
                            $repoatDataModel['created'] = time();
                            $addReport = $this->loadModel("BrandReportModel",$repoatDataModel)->add();
                            // preparing en data
                            $dataEnModel['id_brand'] = $add;
                            $dataEnModel['name'] = $dataValid['success']['name'];
                            $dataEnModel['description'] = $dataValid['success']['description'];
                            $dataEnModel['keywords'] = $dataValid['success']['keywords'];
                            $addEnData = $this->loadModel("BrandEnModel",$dataEnModel)->add();
                            // preparing ar data
                            $dataArModel['id_brand'] = $add;
                            $dataArModel['name'] = $dataValid['success']['ar_name'];
                            $dataArModel['description'] = $dataValid['success']['ar_description'];
                            $dataArModel['keywords'] = $dataValid['success']['ar_keywords'];
                            $addArData = $this->loadModel("BrandArModel",$dataArModel)->add();
                            if(False !== $addEnData && FALSE !== $addArData)
                            {
                               $dataView['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Data Added Successfully Please Wait .. </div>';
                               header("Refresh: 2"); 
                            }else{
                                $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Adding Your Data Please Try Again</div>';
                            }
                        }else{
                            $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Adding Your Data Please Try Again</div>';
                        } 
                    }else{
                        $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Brand Image Is Required (Max Image Size 2MB)</div>';
                    }
                    
                }else{
                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                }
            }
            // get main categories
            $dataView['categories'] = $this->loadModel('CategoryModel')->retrieveAllData("WHERE `id_category` IS NULL AND `status` =? AND `deleted` =?",array(1,1));
            if(is_array($dataView['categories']))
            {
                // get cateogy data And sub categories
                foreach($dataView['categories'] as $key=>$category)
                {
                    $dataView['categoryEn'][$key] = $this->loadModel("CategoryEnModel")->retriveDataById("id_category",$category['id']);
                    $dataView['categoryAr'][$key] = $this->loadModel("CategoryArModel")->retriveDataById("id_category",$category['id']);
                }
            }
            
			$dataView['title'] = "Add Brand";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."brand_add";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        
        public function getAll()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            
            // get all brands
            
            $dataView['brands'] = $this->loadModel("BrandModel")->retrieveAllData("WHERE `deleted` =?",array(1));
            if(is_array($dataView['brands']))
            {
                foreach($dataView['brands'] as $key=>$value)
                {
                    // get ar and en Data
                    $dataView['brandsEn'][$key] = $this->loadModel("BrandEnModel")->retriveDataById("id_brand",$value['id']);
                    $dataView['brandsAr'][$key] = $this->loadModel("BrandArModel")->retriveDataById("id_brand",$value['id']);
                    // get categories
                    $dataView['categoriesEn'][$key] = $this->loadModel("CategoryEnModel")->retriveDataById("id_category",$value['id_category']);
                    $dataView['categoriesAr'][$key] = $this->loadModel("CategoryArModel")->retriveDataById("id_category",$value['id_category']);
                }
            }
            
			$dataView['title'] = "Show / Edit Brand";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."brand_getall";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        
        public function edit_selected()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            // get id from url
            $id = (int)$this->loadRoute()->getSegment(2);
            if($id == 0)
            {
                $this->redirect("Errors","index");
                exit();
            }
            // get data
            $dataView['brand'] = $this->loadModel("BrandModel")->retrieveAllData("WHERE `id` =? AND `deleted` =?",array($id,1));
            if($dataView['brand'] == NULL)
            {
                $this->redirect("Errors","index");
                exit();
            }
            $dataView['brand'] = array_shift($dataView['brand']);
             // get ar and en Data
            $dataView['brandEn'] = $this->loadModel("BrandEnModel")->retriveDataById("id_brand",$id);
            $dataView['brandAr'] = $this->loadModel("BrandArModel")->retriveDataById("id_brand",$id);

            //start Edit Brand
			if(isset($_POST['edit']))
            {
                
                // preparing validation array
                $validationArray = array(
                                            "id_category"=>array(
                                                             "value"=>$this->loadSecurity($_POST['id_category'])->clear(),
                                                             "errorName"=>"Category",
                                                             "rules"=>"required|number"
                                                          ),
                                            "name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['enName'])->clear(),
                                                             "errorName"=>"Brand Name",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "ar_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['arName'])->clear(),
                                                             "errorName"=>"اسم الماركة",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "description"=>array(
                                                             "value"=>$this->loadSecurity($_POST['en_description'])->clear(),
                                                             "errorName"=>"Brand Description",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "ar_description"=>array(
                                                             "value"=>$this->loadSecurity($_POST['ar_description'])->clear(),
                                                             "errorName"=>"وصف الماركة",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "keywords"=>array(
                                                             "value"=>$this->loadSecurity($_POST['en_keywords'])->clear(),
                                                             "errorName"=>"Brand keywords",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "ar_keywords"=>array(
                                                             "value"=>$this->loadSecurity($_POST['ar_keywords'])->clear(),
                                                             "errorName"=>"الكلمات الدليلية",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "status"=>array(
                                                             "value"=>$this->loadSecurity($_POST['status'])->clear(),
                                                             "errorName"=>"Status",
                                                             "rules"=>"number"
                                                          ),
                                  );
                // load validation classs and pass validation data
                $dataValid = $this->loadValidation($validationArray)->formValidate();
                // check if the data is ok
                if(is_array($dataValid) && array_key_exists("success",$dataValid))
                {
                    // prepare data
                    $dataModel['last_update_by'] = $user_id;
                    $dataModel['id_category'] = $dataValid['success']['id_category'];
                    $dataModel['status'] = $dataValid['success']['status'];
                    
                    $updateData = $this->loadModel("BrandModel",$dataModel)->UpdateData("id",$id);
                    if(FALSE !== $updateData)
                    {
                        // preparing en data
                        $dataEnModel['name'] = $dataValid['success']['name'];
                        $dataEnModel['keywords'] = $dataValid['success']['keywords'];
                        $dataEnModel['description'] = $dataValid['success']['description'];
                        $updateEnData = $this->loadModel("BrandEnModel",$dataEnModel)->UpdateData("id_brand",$id);
                        // preparing ar data
                        $dataArModel['name'] = $dataValid['success']['ar_name'];
                        $dataArModel['description'] = $dataValid['success']['ar_description'];
                        $dataArModel['keywords'] = $dataValid['success']['ar_keywords']; 
                        $updateArData = $this->loadModel("BrandArModel",$dataArModel)->UpdateData("id_brand",$id);
                        // update report
                        $reportModel['status'] = $dataValid['success']['status'];
                        $this->loadModel("BrandReportModel",$reportModel)->updateData("id_brand", $id);
                        if(False !== $updateEnData && FALSE !== $updateArData)
                        {
                           $dataView['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Data Updated Successfully Please Wait .. </div>';
                           header("Refresh: 2"); 
                        }else{
                            $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Updating Your Data Please Try Again</div>';
                        }
                    }else{
                        $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Updating Your Data Please Try Again</div>';
                    } 
                    
                }else{
                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                }
            }
            
            // get main categories
            $dataView['categories'] = $this->loadModel('CategoryModel')->retrieveAllData("WHERE `id_category` IS NULL AND `status` =? AND `deleted` =?",array(1,1));
            if(is_array($dataView['categories']))
            {
                // get cateogy data And sub categories
                foreach($dataView['categories'] as $key=>$category)
                {
                    $dataView['categoryEn'][$key] = $this->loadModel("CategoryEnModel")->retriveDataById("id_category",$category['id']);
                    $dataView['categoryAr'][$key] = $this->loadModel("CategoryArModel")->retriveDataById("id_category",$category['id']);
                }
            }
			$dataView['title'] = "Edit Selected Brand";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."brand_edit_selected";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        
        public function update_image()
        {
                //get id
                $id = (int)$_POST['field_id'];
                 if($id == 0)
                {
                    echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                    exit;
                }else{
                        $upload = $this->loadUpload("image_name")->do_upload();
                       // check if there is error on image
                       if(array_key_exists("uploadError",$upload))
                       {
                           echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                            exit;

                       }else{
                           // get user id from session
                           $user_id = $this->loadSession()->getSession("user_id");
                           $dataModel['last_update_by'] = $user_id;
                           $dataModel['image'] = $upload['uploaded'][0];
                           if(false !== $this->loadModel("BrandModel",$dataModel)->updateData("id", $id))
                           {
                               echo $this->loadAjax()->DataToJson(array("status"=>"success","newImage"=>$dataModel['image']));
                                exit; 
                           }else{
                              echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                            exit;
                           }
                       }
                    }  
        }
        public function updateStatus()
        {
                if(isset($_POST['action'],$_POST['id'],$_POST['status']) && $_POST['action'] == "updateStatus")
                {
                    // get User id
                    $id = (int)$_POST['id'];
                    if($id == 0)
                    {
                        $this->redirect("Errors","index");
                        exit;
                    }else{
                        // get current status
                        $currentStatus = $_POST['status'];
                        // if current status = on set it off
                        if($currentStatus == "on")
                        {
                            $setStatus = 2;
                        }else{
                            $setStatus = 1;
                        }
                        // get user id from session
                        $user_id = $this->loadSession()->getSession("user_id");
                        $dataModel['last_update_by'] = $user_id;
                        $dataModel['status'] = $setStatus;
                        if(false !== $this->loadModel("BrandModel",$dataModel)->updateData("id", $id))
                        {
                            $this->loadModel("BrandReportModel",$dataModel)->updateData("id_brand", $id);
                         echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                         exit;
                        }else{
                            echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                            exit;
                        }
                    }
                }
         }
        
        public function delete()
        {
                if(isset($_POST['action'],$_POST['id']) && $_POST['action'] == "deleteData")
                {
                    $id = (int)$_POST['id'];
                    if($id == 0)
                    {
                        $this->redirect("Errors","index");
                        exit;
                    }else{
                        // get user id from session
                        $user_id = $this->loadSession()->getSession("user_id");
                        $dataModel['last_update_by'] = $user_id;
                        $dataModel['deleted'] = 2;
                        if(FALSE !== $this->loadModel("BrandModel",$dataModel)->updateData("id",$id))
                        {
                            $this->loadModel("BrandReportModel",array("deleted"=>2))->updateData("id_brand",$id);
                            echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                            exit;
                        }else{
                            echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                            exit;
                        }
                    }
                 }
         }
        
        
    }

?>