<?php
    class City extends Controller{
		
        
        public function add()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            // get all governates
            $dataView['governates'] = $this->loadModel("GovernateModel")->retrieveAllData("WHERE `deleted` =?",array(1));
            if(is_array($dataView['governates']))
            {
                foreach($dataView['governates'] as $key=>$value)
                {
                    // get ar and en Data
                    $dataView['governatesEn'][$key] = $this->loadModel("GovernateEnModel")->retriveDataById("id_governate",$value['id']);
                    $dataView['governatesAr'][$key] = $this->loadModel("GovernateArModel")->retriveDataById("id_governate",$value['id']);
                }
            }
            
            //start Add Anew city
			if(isset($_POST['add']))
            {
                
                // preparing validation array
                $validationArray = array(
                                            "name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['enName'])->clear(),
                                                             "errorName"=>"City Name",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "ar_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['arName'])->clear(),
                                                             "errorName"=>"اسم المدينة",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "governate"=>array(
                                                             "value"=>$this->loadSecurity($_POST['governate'])->clear(),
                                                             "errorName"=>"Governate",
                                                             "rules"=>"required|number"
                                                          ),
                                            "longitude"=>array(
                                                             "value"=>$this->loadSecurity($_POST['long'])->clear(),
                                                             "errorName"=>"City Longitude",
                                                             "rules"=>"required"
                                                          ),
                                            "latitude"=>array(
                                                             "value"=>$this->loadSecurity($_POST['lat'])->clear(),
                                                             "errorName"=>"City Latitude",
                                                             "rules"=>"required"
                                                          ),
                                            "shipping"=>array(
                                                             "value"=>$this->loadSecurity($_POST['shipping'])->clear(),
                                                             "errorName"=>"Shipping",
                                                          ),
                                            "status"=>array(
                                                             "value"=>$this->loadSecurity($_POST['status'])->clear(),
                                                             "errorName"=>"Status",
                                                             "rules"=>"number"
                                                          ),
                                  );
                // load validation classs and pass validation data
                $dataValid = $this->loadValidation($validationArray)->formValidate();
                // check if the data is ok
                if(is_array($dataValid) && array_key_exists("success",$dataValid))
                {
                    //check if city En Name exists before
                    if(TRUE !== $this->loadModel("CityEnModel")->CheckExists("WHERE `name` =? AND `deleted`=?",array($dataValid['success']['name'],1)))
                    {
                        //check if city Ar Name exists before
                        if(TRUE !== $this->loadModel("CityArModel")->CheckExists("WHERE `name` =? AND `deleted`=?",array($dataValid['success']['ar_name'],1)))
                        {
                            // prepare data
                            $dataModel['id_governate'] = $dataValid['success']['governate'];
                            $dataModel['longitude'] = $dataValid['success']['longitude'];
                            $dataModel['latitude'] = $dataValid['success']['latitude'];
                            $dataModel['shipping'] = $dataValid['success']['shipping'];
                            $dataModel['id_admin'] = $user_id;
                            $dataModel['status'] = $dataValid['success']['status'];
                            $dataModel['created'] = time();
                            $add = $this->loadModel("CityModel",$dataModel)->add();
                            if(FALSE !== $add)
                            {
                                // preparing en data
                                $dataEnModel['id_city'] = $add;
                                $dataEnModel['name'] = $dataValid['success']['name'];
                                $dataEnModel['status'] = $dataValid['success']['status'];
                                $dataEnModel['created'] = time();
                                $addEnData = $this->loadModel("CityEnModel",$dataEnModel)->add();
                                // preparing ar data
                                $dataArModel['id_city'] = $add;
                                $dataArModel['name'] = $dataValid['success']['ar_name'];
                                $dataArModel['status'] = $dataValid['success']['status'];
                                $dataArModel['created'] = time();
                                $addArData = $this->loadModel("CityArModel",$dataArModel)->add();
                                if(False !== $addEnData && FALSE !== $addArData)
                                {
                                   $dataView['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Data Added Successfully Please Wait .. </div>';
                                   header("Refresh: 2"); 
                                }else{
                                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Adding Your Data Please Try Again1</div>';
                                }
                            }else{
                                $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Adding Your Data Please Try Again2</div>';
                            }
                        }else{
                            $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> City Arabic Name Exists Before</div>';
                        }
                    }else{
                        $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> City English Name Exists Before</div>';
                    }
                }else{
                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                }
            }
            
			$dataView['title'] = "Add City";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."city_add";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        
        public function getAll()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            
            // get all cities
            $dataView['cities'] = $this->loadModel("CityModel")->retrieveAllData("WHERE `deleted` =?",array(1));
            if(is_array($dataView['cities']))
            {
                foreach($dataView['cities'] as $key=>$value)
                {
                    // get ar and en Data
                    $dataView['citiesEn'][$key] = $this->loadModel("CityEnModel")->retriveDataById("id_city",$value['id']);
                    $dataView['citiesAr'][$key] = $this->loadModel("CityArModel")->retriveDataById("id_city",$value['id']);
                }
            }
            
			$dataView['title'] = "Show / Edit Cities";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."city_getall";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        
        public function edit_selected()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            // get id from url
            $id = (int)$this->loadRoute()->getSegment(2);
            if($id == 0)
            {
                $this->redirect("error","index");
                exit();
            }
            // get data
            $dataView['city'] = $this->loadModel("CityModel")->retrieveAllData("WHERE `id` =? AND `deleted` =?",array($id,1));
            if($dataView['city'] == NULL)
            {
                $this->redirect("Errors","index");
                exit();
            }
            $dataView['city'] = array_shift($dataView['city']);
             // get ar and en Data
            $dataView['cityEn'] = $this->loadModel("CityEnModel")->retriveDataById("id_city",$id);
            $dataView['cityAr'] = $this->loadModel("CityArModel")->retriveDataById("id_city",$id);

            //start edit city
			if(isset($_POST['edit']))
            {
                
                // preparing validation array
                $validationArray = array(
                                            "name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['enName'])->clear(),
                                                             "errorName"=>"City Name",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "ar_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['arName'])->clear(),
                                                             "errorName"=>"اسم المدينة",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "governate"=>array(
                                                             "value"=>$this->loadSecurity($_POST['governate'])->clear(),
                                                             "errorName"=>"Governate",
                                                             "rules"=>"required|number"
                                                          ),
                                            "longitude"=>array(
                                                             "value"=>$this->loadSecurity($_POST['long'])->clear(),
                                                             "errorName"=>"City Longitude",
                                                             "rules"=>"required"
                                                          ),
                                            "latitude"=>array(
                                                             "value"=>$this->loadSecurity($_POST['lat'])->clear(),
                                                             "errorName"=>"City Latitude",
                                                             "rules"=>"required"
                                                          ),
                                            "shipping"=>array(
                                                             "value"=>$this->loadSecurity($_POST['shipping'])->clear(),
                                                             "errorName"=>"Shipping",
                                                          ),
                                            "status"=>array(
                                                             "value"=>$this->loadSecurity($_POST['status'])->clear(),
                                                             "errorName"=>"Status",
                                                             "rules"=>"number"
                                                          ),
                                  );
                // load validation classs and pass validation data
                $dataValid = $this->loadValidation($validationArray)->formValidate();
                // check if the data is ok
                if(is_array($dataValid) && array_key_exists("success",$dataValid))
                {
                    //check if city En Name exists before
                    if(TRUE !== $this->loadModel("CityEnModel")->CheckExists("WHERE `name` =? AND `id_city` != ? AND `deleted`=?",array($dataValid['success']['name'],$id,1)))
                    {
                        //check if country Ar Name exists before
                        if(TRUE !== $this->loadModel("CityArModel")->CheckExists("WHERE `name` =? AND `id_city` != ? AND `deleted`=?",array($dataValid['success']['ar_name'],$id,1)))
                        {
                            // prepare data
                            $dataModel['id_governate'] = $dataValid['success']['governate'];
                            $dataModel['longitude'] = $dataValid['success']['longitude'];
                            $dataModel['latitude'] = $dataValid['success']['latitude'];
                            $dataModel['shipping'] = $dataValid['success']['shipping'];
                            $dataModel['id_admin'] = $user_id;
                            $dataModel['status'] = $dataValid['success']['status'];
                            $update = $this->loadModel("CityModel",$dataModel)->updateData('id',$id);
                            if(FALSE !== $update)
                            {
                                // preparing en data
                                $dataEnModel['name'] = $dataValid['success']['name'];
                                $dataEnModel['status'] = $dataValid['success']['status'];
                                $updateEnData = $this->loadModel("CityEnModel",$dataEnModel)->updateData("id_city",$id);
                                // preparing ar data
                                $dataArModel['name'] = $dataValid['success']['ar_name'];
                                $dataArModel['status'] = $dataValid['success']['status'];
                                $updateArData = $this->loadModel("CityArModel",$dataArModel)->updateData("id_city",$id);
                                if(False !== $updateEnData && FALSE !== $updateArData)
                                {
                                   $dataView['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Data Updated Successfully Please Wait .. </div>';
                                   header("Refresh: 2"); 
                                }else{
                                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Updating Your Data Please Try Again1</div>';
                                }
                            }else{
                                $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Updating Your Data Please Try Again2</div>';
                            }
                        }else{
                            $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> City Arabic Name Exists Before</div>';
                        }
                    }else{
                        $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> City English Name Exists Before</div>';
                    }
                }else{
                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                }
            }
            // get all governates
            $dataView['governates'] = $this->loadModel("GovernateModel")->retrieveAllData("WHERE `deleted` =?",array(1));
            if(is_array($dataView['governates']))
            {
                foreach($dataView['governates'] as $key=>$value)
                {
                    // get ar and en Data
                    $dataView['governatesEn'][$key] = $this->loadModel("GovernateEnModel")->retriveDataById("id_governate",$value['id']);
                    $dataView['governatesAr'][$key] = $this->loadModel("GovernateArModel")->retriveDataById("id_governate",$value['id']);
                }
            }
            
            // get all interests
			$dataView['title'] = "Edit Selected City";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."city_edit_selected";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        
        public function updateStatus()
        {
                if(isset($_POST['action'],$_POST['id'],$_POST['status']) && $_POST['action'] == "updateStatus")
                {
                    // get User id
                    $id = (int)$_POST['id'];
                    if($id == 0)
                    {
                        $this->redirect("Errors","index");
                        exit;
                    }else{
                        // get current status
                        $currentStatus = $_POST['status'];
                        // if current status = on set it off
                        if($currentStatus == "on")
                        {
                            $setStatus = 2;
                        }else{
                            $setStatus = 1;
                        }
                        $dataModel['status'] = $setStatus;

                        if(false !== $this->loadModel("CityModel",$dataModel)->updateData("id", $id))
                        {
                            $this->loadModel("CityEnModel",$dataModel)->updateData("id_city", $id);
                             $this->loadModel("CityArModel",$dataModel)->updateData("id_city", $id);
                         echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                         exit;
                        }else{
                            echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                            exit;
                        }
                    }
                }
         }
        public function delete()
        {
                if(isset($_POST['action'],$_POST['id']) && $_POST['action'] == "deleteData")
                {
                    $id = (int)$_POST['id'];
                    if($id == 0)
                    {
                        $this->redirect("Errors","index");
                        exit;
                    }else{
                        if(FALSE !== $this->loadModel("CityModel",array("deleted"=>2))->updateData("id",$id))
                        {
                            $this->loadModel("CityEnModel",array("deleted"=>2))->updateData("id_city",$id);
                            $this->loadModel("CityArModel",array("deleted"=>2))->updateData("id_city",$id);
                            echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                            exit;
                        }else{
                            echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                            exit;
                        }
                    }
                 }
         }
        
        public function retreive_all_cities_by_governate_id()
        {
            if(isset($_POST['governate_id'])){
                $governate_id =  (int)$_POST['governate_id'];
                if($governate_id !== 0)
                {
                     $allCities = $this->loadModel("CityModel")->retrieveAllData("WHERE `id_governate` = ? AND `deleted` =? AND `status` =?",array($governate_id, 1,1));
                    if(is_array($allCities))
                    {
                        foreach($allCities as $key=>$value)
                        {
                           $allCitiesEn[$key] = $this->loadModel("CityEnModel")->retriveDataById("id_city",$value['id']);
                           $allCitiesAr[$key] = $this->loadModel("CityArModel")->retriveDataById("id_city",$value['id']);
                        }
                        $response['status'] = "success";
                        $response['cities'] = $allCities;
                        $response['citiesEn'] = $allCitiesEn;
                        $response['citiesAr'] = $allCitiesAr;
                        echo $this->loadAjax()->DataToJson($response);
                        exit;
                    }else{
                        echo $this->loadAjax()->DataToJson(array("status"=>"null"));
                        exit;   
                    }
                }else{
                    echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                    exit;
                }
            }else{
                echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                exit;
            }
        }
        
    }

?>