<?php
    class Customer extends Controller{
		
        
        public function add()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            
            //start Add Anew Employee
			if(isset($_POST['add']))
            {
                
                // preparing validation array
                $validationArray = array(
                                            "name"=>array(
                                                "value"=> $this->loadSecurity($_POST['name'])->clear(),
                                                "errorName"=>"Vendor Name",
                                                "rules"=>"required|min-length[3]|max-length[50]"
                                            ),
                                            "email"=>array(
                                                "value"=> $this->loadSecurity($_POST['email'])->clear(),
                                                "errorName"=>"Email",
                                                "rules"=>"required|email"
                                            ),
                                            "phone"=>array(
                                                "value"=> $this->loadSecurity($_POST['phone'])->clear(),
                                                "errorName"=>"Phone",
                                                "rules"=>"required|max-length[11]"
                                            ),

                                            "city_id"=>array(
                                                "value"=> $this->loadSecurity($_POST['city_id'])->clear(),
                                                "errorName"=>"City",
                                                "rules"=>"required|number"
                                            ),
                                            "address"=>array(
                                                "value"=> $this->loadSecurity($_POST['address'])->clear(),
                                                "errorName"=>"Address",
                                                "rules"=>"required|min-length[3]|max-length[50]"
                                            ),
                                            "gender"=>array(
                                                "value"=> $this->loadSecurity($_POST['gender'])->clear(),
                                                "errorName"=>"Gender",
                                                "rules"=>"required|number"
                                            ),

                                            "password"=>array(
                                                "value"=> $this->loadSecurity($_POST['password'])->clear(),
                                                "errorName"=>"password",
                                                "rules"=>"required|min-length[6]|max-length[50]|sha1_md5"
                                            ),
                                            "re_password"=>array(
                                                 "value"=>$this->loadSecurity(sha1(md5($_POST['repassword'])))->clear(),
                                                 "errorName"=>"Re-Password",
                                                 "rules"=>"required|match[password]"
                                              ),

                                            "status"=>array(
                                                "value"=> $this->loadSecurity($_POST['status'])->clear(),
                                                "errorName"=>"Status",
                                                "rules"=>"required|number"
                                            )
                                  );
                // load validation classs and pass validation data
                $dataValid = $this->loadValidation($validationArray)->formValidate();
                // check if the data is ok
                if(is_array($dataValid) && array_key_exists("success",$dataValid))
                { 
                    //check if Mail exists before
                    if(TRUE !== $this->loadModel("UserModel")->CheckExists("WHERE `mail` =? AND `deleted`=?",array($dataValid['success']['email'],1)))
                    {
                        //check if Phone exists before
                        if(TRUE !== $this->loadModel("UserModel")->CheckExists("WHERE `phone` =? AND `deleted`=?",array($dataValid['success']['phone'],1)))
                        {
                            // start upload Employee Profile Pic
                            $upload = $this->loadUpload("profile_picture")->do_upload();
                            // check if there is error on image
                            if(!array_key_exists("uploadError",$upload))
                            {

                                    // preparing user model
                                    $userModel['name'] = $dataValid['success']['name'];
                                    $userModel['phone'] = $dataValid['success']['phone'];
                                    $userModel['mail'] = $dataValid['success']['email'];
                                    $userModel['city_id'] = $dataValid['success']['city_id'];
                                    $userModel['password'] = $dataValid['success']['password'];
                                    $userModel['address'] = $dataValid['success']['address'];
                                    $userModel['photo'] = $upload['uploaded'][0];
                                    $userModel['gender'] = $dataValid['success']['gender'];
                                    $userModel['job_type'] = 3;
                                    $userModel['verified'] = 1;
                                    $userModel['created_by'] = $user_id;
                                    $userModel['created'] = time();
                                    $userModel['last_updated_by'] = $user_id;
                                    $userModel['status'] = $dataValid['success']['status'];
                                    // add user 
                                    $add = $this->loadModel("UserModel", $userModel)->add();
                                    // call user Model
                                        if(FALSE !== $add)
                                        {
                                            $dataView['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Data Added Successfully Please Wait .. </div>';
                                             header("Refresh: 2");
                                        }else{
                                            // delete user
                                            $this->loadModel("UserModel",array("deleted"=>2))->updateData("id",$add);
                                            $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Adding  Data ...</div>';
                                        }
                            }else{
                                $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> User Profile Image Is Required (Max Image Size 2MB)</div>';
                            }
                        }else{
                            $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> User Phone Exists Before </div>';
                        }
                    }else{
                        $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> User Email Exists Before </div>';
                    }
                }else{
                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                }
            }
            // get all countries 
            $dataView["allCountries"] = $this->loadModel("CountryModel")->retrieveAllData("WHERE `deleted` =? AND `status` =?",array(1,1));
            if(is_array($dataView['allCountries']))
            {
                foreach($dataView['allCountries'] as $key=>$value)
                {
                    // get ar and en data
                    $dataView['counteriesEn'][$key] = $this->loadModel("CountryEnModel")->retriveDataById("id_country",$value['id']);
                    $dataView['counteriesAr'][$key] = $this->loadModel("CountryArModel")->retriveDataById("id_country",$value['id']);
                
                    // get last updated by and created by
                    $dataView['createdBy'][$key] = $this->loadModel("UserModel")->retriveDataById("id",$value['created_by']);
                    $dataView['lastUpdateBy'][$key] = $this->loadModel("UserModel")->retriveDataById("id",$value['last_updated_by']);
                }
            }

            $dataView['title'] = "Add a New Customer";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "customer" . DIRECTORY_SEPARATOR . "customer__add";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        
        public function getAll()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            
            // get all vendors
            $dataView['users'] =  $this->loadModel("UserModel")->retrieveAllData("WHERE `job_type` =? AND `deleted` =?",array(3,1));
			$dataView['title'] = "Show / Edit Customer";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
			$TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "customer" . DIRECTORY_SEPARATOR . "customer___getall";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        
        public function edit_selected()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            // get id from url
            $id = (int)$this->loadRoute()->getSegment(2);
            if($id == 0)
            {
                $this->redirect("Errors","index");
                exit();
            }
            $dataView['user'] = $this->loadModel("UserModel")->retrieveAllData("WHERE `id` =?  AND `deleted` =?",array($id,1));
            if($dataView['user'] == NULL)
            {
                $this->redirect("Errors","index");
                exit();
            }
            $dataView['user'] = array_shift($dataView['user']);


            //start Edit employee
			if(isset($_POST['edit']))
            {
                
                // preparing validation array
                $validationArray = array(
                                            "name"=>array(
                                                "value"=> $this->loadSecurity($_POST['name'])->clear(),
                                                "errorName"=>"Employee Name",
                                                "rules"=>"required|min-length[3]|max-length[50]"
                                            ),
                                            "mail"=>array(
                                                "value"=> $this->loadSecurity($_POST['email'])->clear(),
                                                "errorName"=>"Email",
                                                "rules"=>"required|email"
                                            ),
                                            "phone"=>array(
                                                "value"=> $this->loadSecurity($_POST['phone'])->clear(),
                                                "errorName"=>"Phone",
                                                "rules"=>"required"
                                            ),

                                            "city_id"=>array(
                                                "value"=> $this->loadSecurity($_POST['city_id'])->clear(),
                                                "errorName"=>"City",
                                                "rules"=>"required|number"
                                            ),
                                            "address"=>array(
                                                "value"=> $this->loadSecurity($_POST['address'])->clear(),
                                                "errorName"=>"Address",
                                                "rules"=>"required|min-length[3]|max-length[50]"
                                            ),
                                            "gender"=>array(
                                                "value"=> $this->loadSecurity($_POST['gender'])->clear(),
                                                "errorName"=>"Gender",
                                                "rules"=>"required|number"
                                            ),

                                            "status"=>array(
                                                "value"=> $this->loadSecurity($_POST['status'])->clear(),
                                                "errorName"=>"Status",
                                                "rules"=>"required|number"
                                            )
                                  );
                // load validation classs and pass validation data
                $dataValid = $this->loadValidation($validationArray)->formValidate();
                // check if the data is ok
                if(is_array($dataValid) && array_key_exists("success",$dataValid))
                { 
                    //check if Mail exists before
                    if(TRUE !== $this->loadModel("UserModel")->CheckExists("WHERE `mail` =? AND `id`!=? AND `deleted`=?",array($dataValid['success']['mail'],$id,1)))
                    {
                        //check if User phone exists before
                        if(TRUE !== $this->loadModel("UserModel")->CheckExists("WHERE `phone` =? AND `id`!=? AND `deleted`=?",array($dataValid['success']['phone'],$id,1)))
                        {
                            // preparing user model
                            $userModel['name'] = $dataValid['success']['name'];
                            $userModel['phone'] = $dataValid['success']['phone'];
                            $userModel['mail'] = $dataValid['success']['mail'];
                            $userModel['city_id'] = $dataValid['success']['city_id'];
                            $userModel['address'] = $dataValid['success']['address'];
                            $userModel['gender'] = $dataValid['success']['gender'];
                            $userModel['last_updated_by'] = $user_id;
                            $userModel['status'] = $dataValid['success']['status'];
                            // update user 
                            $updateUser = $this->loadModel("UserModel", $userModel)->updateData("id",$id);
                            // call user Model 
                            if(FALSE !== $updateUser)
                            {
								$dataView['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Data Updated Successfully Please Wait .. </div>';
								header("Refresh: 2");
                            }else{
                                $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Updating User Data</div>';
                            }
                        }else{
                            $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> User Phone Exists Before </div>';
                        }
                    }else{
                        $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> User Email Exists Before </div>';
                    }
                }else{
                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                }
            }
            
            // get all countries 
            $dataView["allCountries"] = $this->loadModel("CountryModel")->retrieveAllData("WHERE `deleted` =? AND `status` =?",array(1,1));
            if(is_array($dataView['allCountries']))
            {
                foreach($dataView['allCountries'] as $key=>$value)
                {
                    // get ar and en data
                    $dataView['counteriesEn'][$key] = $this->loadModel("CountryEnModel")->retriveDataById("id_country",$value['id']);
                    $dataView['counteriesAr'][$key] = $this->loadModel("CountryArModel")->retriveDataById("id_country",$value['id']);
                }
            }
            // get all cities 
            $dataView["allCities"] = $this->loadModel("CityModel")->retrieveAllData("WHERE `deleted` =? AND `status` =?",array(1,1));
            if(is_array($dataView["allCities"]))
            {
                foreach($dataView["allCities"] as $key => $city)
                {
                   // get ar and en Data
                    $dataView['citiesEn'][$key] = $this->loadModel("CityEnModel")->retriveDataById("id_city",$city['id']);
                    $dataView['citiesAr'][$key] = $this->loadModel("CityArModel")->retriveDataById("id_city",$city['id']);
                }
            }
            
            // get alladmin Types

            // set page title
			$dataView['title'] = "Edit Selected Customer";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "customer" . DIRECTORY_SEPARATOR ."customer__edit_selected";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        
        public function show_selected()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            // get id from url
            $id = (int)$this->loadRoute()->getSegment(2);
            if($id == 0)
            {
                $this->redirect("Errors","index");
                exit();
            }
            // get data
            $dataView['user'] = $this->loadModel("UserModel")->retrieveAllData("WHERE `id` =?  AND `deleted` =?",array($id,1));
            if($dataView['user'] == NULL)
            {
                $this->redirect("Errors","index");
                exit();
            }
            $dataView['user'] = array_shift($dataView['user']);

            // get employee city
            $dataView['vindorCity'] = $this->loadModel("CityEnModel")->retriveDataById("id_city",$dataView['user']['city_id']);
            
            // get user created by
            $dataView['createdBy'] = $this->loadModel("UserModel")->retriveDataById("id",$dataView['user']['created_by']);
            // get last update by
            $dataView['LastUpdatedBy'] = $this->loadModel("UserModel")->retriveDataById("id",$dataView['user']['last_updated_by']);
            // set page title
			$dataView['title'] = "View Selected vendor";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "customer" . DIRECTORY_SEPARATOR ."customer___show_selected";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }


		public function updateStatus()
		{
			if(isset($_POST['action'],$_POST['id'],$_POST['status']) && $_POST['action'] == "updateStatus")
			{
				// get User id
				$id = (int)$_POST['id'];
				if($id == 0)
				{
					$this->redirect("Errors","index");
					exit;
				}else{
					// get current status
					$currentStatus = $_POST['status'];
					// if current status = on set it off
					if($currentStatus == "on")
					{
						$setStatus = 2;
					}else{
						$setStatus = 1;
					}
					$dataModel['status'] = $setStatus;
					$dataModel['last_updated_by'] = $this->loadSession()->getSession("user_id");
					if(false !== $this->loadModel("UserModel",$dataModel)->updateData("id", $id))
					{
						echo $this->loadAjax()->DataToJson(array("status"=>"success"));
						exit;
					}else{
						echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
						exit;
					}
				}
			}
		}
        public function update_image()
        {
                //get id
                $id = (int)$_POST['field_id'];
                 if($id == 0)
                {
                    $this->redirect("Errors","index");
                    exit;
                }else{
                        $upload = $this->loadUpload("image_name")->do_upload();
                       // check if there is error on image
                       if(array_key_exists("uploadError",$upload))
                       {
                           echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                            exit;

                       }else{
                           // get user id from session
                           $last_updated_by = $this->loadSession()->getSession("user_id");
                           $dataModel['photo'] = $upload['uploaded'][0];
                           $dataModel['last_updated_by'] = $last_updated_by;
                           
                           if(false !== $this->loadModel("UserModel",$dataModel)->updateData("id", $id))
                           {
                               // update employee table
                               echo $this->loadAjax()->DataToJson(array("status"=>"success","newImage"=>$dataModel['photo']));
                               exit; 
                           }else{
                              echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                            exit;
                           }
                       }
                    }  
        }
        public function delete()
        {
                if(isset($_POST['action'],$_POST['id']) && $_POST['action'] == "deleteData")
                {
                    $id = (int)$_POST['id'];
                    if($id == 0)
                    {
                        $this->redirect("Errors","index");
                        exit;
                    }else{
                        // get user id from session
                        $last_updated_by = $this->loadSession()->getSession("user_id");
                        if(FALSE !== $this->loadModel("UserModel",array("deleted"=>2,"last_updated_by"=>$last_updated_by))->updateData("id", $id))
                        {
                            // update employee table
                            echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                            exit;
                        }else{
                            echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                            exit;
                        }
                    }
                 }
         }
        public function update_password()
        {
            if(isset($_POST['action']) && $_POST['action'] == 'editPass')
            {
               // preparing validation array
                $validationArray = array(
                                        "user_id"=>array(
                                                             "value"=>$this->loadSecurity($_POST['user_id'])->clear(),
                                                             "errorName"=>"User Id",
                                                             "rules"=>"required|number"
                                                          ),
                                            "password"=>array(
                                                             "value"=>$this->loadSecurity($_POST['password'])->clear(),
                                                             "errorName"=>"New Password",
                                                             "rules"=>"required|min-length[6]|sha1_md5"
                                                          ),
                                            "re_password"=>array(
                                                             "value"=>$this->loadSecurity(sha1(md5($_POST['repassword'])))->clear(),
                                                             "errorName"=>"Re-Password",
                                                             "rules"=>"required|match[password]"
                                                          )
                                  );
                // load validation classs and pass validation data
                $dataValid = $this->loadValidation($validationArray)->formValidate();
                // check if the data is ok
                if(is_array($dataValid) && array_key_exists("success",$dataValid))
                {
                    $user_id = $dataValid['success']['user_id'];
                    // unset old password from success array
                    unset($dataValid['success']['re_password']);
                    unset($dataValid['success']['user_id']);
                    // get user id from session
                    $dataValid['success']['last_updated_by'] = $this->loadSession()->getSession("user_id");
                    if(false !== $this->loadModel("UserModel",$dataValid['success'])->updateData("id",$user_id))
                    {
                        $response['status'] = "success";
                        $response['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Data Updated Successfully. </div>';
                        echo $this->loadAjax()->DataToJson($response);
                        exit;
                    }else{
                        $response['status'] = "faild";
                        $response['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Updating Your Data</div>';
                        echo $this->loadAjax()->DataToJson($response);
                        exit;
                    }
                    
                }else{
                    $response['status'] = "faild";
                    $response['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                    echo $this->loadAjax()->DataToJson($response);
                    exit;
                } 
            }
        }
        public function update_ssn_image()
        {
                //get id
                $id = (int)$_POST['field_id'];
                 if($id == 0)
                {
                    echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                    exit;
                }else{
                        $upload = $this->loadUpload("image_name")->do_upload();
                       // check if there is error on image
                       if(array_key_exists("uploadError",$upload))
                       {
                           echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                            exit;

                       }else{
                           $dataModel['ssn_image'] = $upload['uploaded'][0];
                           if(false !== $this->loadModel("VendorModel",$dataModel)->updateData("id_user", $id))
                           {
                               echo $this->loadAjax()->DataToJson(array("status"=>"success","newImage"=>$dataModel['ssn_image']));
                                exit; 
                           }else{
                              echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                             exit;
                           }
                       }
                    }

        }
        public function ShowAddedProduct()
		{
			/******** start header code ********/
			if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
			{
				// get user id from session
				$user_id = $this->loadSession()->getSession("user_id");
				// get user data for header
				$dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
				$dataView['vendorData'] = $this->loadModel("VendorModel")->retriveDataById("id_user",$user_id);
				if($dataView['userData'] == NULL)
				{
					$this->redirect("Errors","index");
					exit();
				}
			}else{
				$this->redirect("admin","login");
			}

			/******* end header code *******/
			// get vendor id from url
			$id=(int)$this->loadRoute()->getSegment(2);
			if($id == null)
			{
				$this->redirect("Errors","index");
				exit();
			}
			//get appended product
			$dataView['vendorProduct']=$this->loadModel("VendorAppendPproductQuantityModel")->retrieveAllData("WHERE `id_vendor`=? AND `deleted`=?",array($id,1));
			if(is_array($dataView['vendorProduct']))
			{
				foreach ($dataView['vendorProduct'] as $key=>$value)
				{
					$dataView['productAr'][$key]=$this->loadModel("offerArModel")->retriveDataById('id_offer',$value['id_product']);
					$dataView['productEn'][$key]=$this->loadModel("offerEnModel")->retriveDataById('id_offer',$value['id_product']);
				}
			}

			// check vendor data
			$dataView['title'] = " Show Added Product";
			// global Template Config
			global $TEMPLATE_BACK_END ;
			// set content
			$TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "vendor" . DIRECTORY_SEPARATOR ."vendor_product_getall";
			// load template
			$this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();

		}
        
    }

?>