<?php
    class Home extends Controller{
		
        
        public function index()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
			$dataView['today_date'] = date('Y-m-d');
            $dataView['tomorowDay'] = date('Y-m-d', strtotime(' +1 day'));
            $dataView['next1Day'] = date('Y-m-d', strtotime(' +2 day'));
            $dataView['next7Day'] = date('Y-m-d', strtotime(' +7 day'));
            $dataView['before1Day'] = date('Y-m-d', strtotime(' -1 day'));
            $dataView['before2Day'] = date('Y-m-d', strtotime(' -2 day'));
            $dataView['before3Day'] = date('Y-m-d', strtotime(' -3 day'));
			// start get count of data
            $dataView['total_categories'] = $this->loadModel("CategoryModel")->retrieveDataByQuery("SELECT COUNT(`id`) as `count` FROM `category` WHERE `deleted` =?",array(1));
            $dataView['total_orders'] = $this->loadModel("CustomerOrderModel")->retrieveDataByQuery("SELECT COUNT(`id`) as `count` FROM `customer_order` WHERE `deleted` =?",array(1));
            $dataView['total_brands'] = $this->loadModel("BrandModel")->retrieveDataByQuery("SELECT COUNT(`id`) as `count` FROM `brand` WHERE `deleted` =?",array(1));
            $dataView['total_employees'] = $this->loadModel("UserModel")->retrieveDataByQuery("SELECT COUNT(`id`) as `count` FROM `user` WHERE `job_type` = ? AND `deleted` =?",array(1,1));
            $dataView['total_payment_wayes'] = $this->loadModel("PaymentWayModel")->retrieveDataByQuery("SELECT COUNT(`id`) as `count` FROM `payment_way` WHERE  `deleted` =?",array(1));
            $dataView['total_users'] = $this->loadModel("UserModel")->retrieveDataByQuery("SELECT COUNT(`id`) as `count` FROM `user` WHERE `deleted` =?",array(1));
            $dataView['total_active_users'] = $this->loadModel("UserModel")->retrieveDataByQuery("SELECT COUNT(`id`) as `count` FROM `user` WHERE `status` =? AND `deleted` =?",array(1,1));
            $dataView['total_un_active_users'] = $this->loadModel("UserModel")->retrieveDataByQuery("SELECT COUNT(`id`) as `count` FROM `user` WHERE `status` =? AND `deleted` =?",array(2,1));
            // get today data
            $dataView['today_orders'] = $this->loadModel("CustomerOrderModel")->retrieveDataByQuery("SELECT COUNT(`id`) as `count` FROM `customer_order` WHERE `created` >= ? AND `status` =? AND `deleted` =?",array(strtotime($dataView['today_date']),1,1));
            $dataView['today_offers'] = $this->loadModel("OfferModel")->retrieveDataByQuery("SELECT COUNT(`id`) as `count` FROM `offer` WHERE `created` >= ? AND `status` =? AND `deleted` =?",array(strtotime($dataView['today_date']),1,1));
            $dataView['today_registrations'] = $this->loadModel("UserModel")->retrieveDataByQuery("SELECT COUNT(`id`) as `count` FROM `user` WHERE `created` >= ? AND `status` =? AND `deleted` =?",array(strtotime($dataView['today_date']),1,1));
            // gat data for charts
            $dataView['before1DayOrders'] = $this->loadModel("RequestModel")->retrieveDataByQuery("SELECT COUNT(`id`) as `count` FROM `request` WHERE `created` BETWEEN ? AND ? AND `status` =? AND `deleted` =?",array(strtotime($dataView['before1Day']),strtotime($dataView['today_date']),1,1));
            $dataView['before2DayOrders'] = $this->loadModel("RequestModel")->retrieveDataByQuery("SELECT COUNT(`id`) as `count` FROM `request` WHERE `created` BETWEEN ? AND ? AND `status` =? AND `deleted` =?",array(strtotime($dataView['before2Day']),strtotime($dataView['before1Day']),1,1));
            $dataView['before3DayOrders'] = $this->loadModel("RequestModel")->retrieveDataByQuery("SELECT COUNT(`id`) as `count` FROM `request` WHERE `created` BETWEEN ? AND ? AND `status` =? AND `deleted` =?",array(strtotime($dataView['before3Day']),strtotime($dataView['before2Day']),1,1));
            $dataView['activeUsersCount'] = ($dataView['total_users'][0]['count'] != 0) ? ($dataView['total_active_users'][0]['count'] / $dataView['total_users'][0]['count']) : 0 ;
            $dataView['unActiveUsersCount'] = ($dataView['total_users'][0]['count'] != 0) ? ($dataView['total_un_active_users'][0]['count'] / $dataView['total_users'][0]['count']) : 0 ;
            
            $dataView['today_requests_orders'] = $this->loadModel("RequestModel")->retrieveAllData("WHERE `created` >= ? AND `deleted` =?",array(strtotime($dataView['today_date']),1));
            if(is_array($dataView['today_requests_orders']))
            {
                foreach($dataView['today_requests_orders'] as $key=>$value)
                {
                    $dataView['today_orders_offers'][$key] = $this->loadModel("OfferModel")->retriveDataById("id",$value['id_offer']);
                }
            }	
            $dataView['today_requests_orders']=$this->loadModel("CustomerOrderModel")->retrieveAllData("WHERE `created` >=? AND `deleted` =?",array(strtotime($dataView['today_date']),1));
			//get order data
			if(is_array($dataView['today_requests_orders']))
			{
				foreach ($dataView['today_requests_orders'] as $key =>$value):
					//get order status
                    // get order status
                    $oderLastStatus = $this->loadModel("TrackingOrderStatus")->retrieveAllData("WHERE `id_order` = ? AND `deleted` =? ORDER BY `id` DESC LIMIT 1",array($value['id'],1));
					$dataView['OrderStatus_ar'][$key]=$this->loadModel("OrderStatusArModel")->retriveDataById('id_order_status',$oderLastStatus[0]['id_order_status']);
					$dataView['OrderStatus_En'][$key]=$this->loadModel("OrderStatusEnModel")->retriveDataById('id_order_status',$oderLastStatus[0]['id_order_status']);
					$dataView['cutomer'][$key]=$this->loadModel("UserModel")->retriveDataById('id',$value['id_customer']);
				endforeach;
			}
            // get search words
            $dataView['searchWords'] = $this->loadModel("SearchReportModel")->retrieveAllData("WHERE `status` =? AND `deleted` =?",array(1,1));
            // get today request
			$today = date('Y/m/d');
			// start get today service request
			$dataView['serviceRequest']=$this->loadModel("ServiceRequestModel")->retrieveAllData("WHERE `created` >=? AND `deleted` =?",array(strtotime($today),1));
			if(is_array($dataView['serviceRequest']))
			{
				//get customer data
				foreach ($dataView['serviceRequest'] as $key=>$value):
					$dataView['requested_customer'][$key]=$this->loadModel("UserModel")->retriveDataById('id',$value['id_customer']);
					//get  arabic and english service data
					$dataView['serviceArTitle'][$key]=$this->loadModel("ServiceArModel")->retriveDataById('id_service',$value['id_service']);
					$dataView['serviceEnTitle'][$key]=$this->loadModel("ServiceEnModel")->retriveDataById('id_service',$value['id_service']);
				endforeach;
			}
			//get today  service request count
			$dataView['todayServicRequestCount']=count($dataView['serviceRequest']);
			// end  get service request data
            $dataView['title'] = "Home Page";
			 // global Template Config
			 global $TEMPLATE_BACK_END ;
			 // set content
			 $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."home_page";
			 // load template
			 $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        
    }

?>