<?php
    class Product extends Controller{
		
        
        public function add()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("error","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            
            
            //start Add Anew Data
			if(isset($_POST['add']))
            {
                
                // preparing validation array
                $validationArray = array(
                                            "id_category"=>array(
                                                             "value"=>$this->loadSecurity($_POST['id_category'])->clear(),
                                                             "errorName"=>"Category",
                                                             "rules"=>"required|number"
                                                          ),
                                            "name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['enName'])->clear(),
                                                             "errorName"=>"Product Name",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "ar_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['arName'])->clear(),
                                                             "errorName"=>"اسم  المنتج",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "description"=>array(
                                                             "value"=>$this->loadSecurity($_POST['en_description'])->clear(),
                                                             "errorName"=>"حقخيعؤف Description",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "ar_description"=>array(
                                                             "value"=>$this->loadSecurity($_POST['ar_description'])->clear(),
                                                             "errorName"=>"وصف المنتج",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "keywords"=>array(
                                                             "value"=>$this->loadSecurity($_POST['en_keywords'])->clear(),
                                                             "errorName"=>" keywords",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "ar_keywords"=>array(
                                                             "value"=>$this->loadSecurity($_POST['ar_keywords'])->clear(),
                                                             "errorName"=>"الكلمات الدليلية",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "status"=>array(
                                                             "value"=>$this->loadSecurity($_POST['status'])->clear(),
                                                             "errorName"=>"Status",
                                                             "rules"=>"number"
                                                          ),
															"special"=>array(
																"value"=>$this->loadSecurity($_POST['special'])->clear(),
																"errorName"=>"special Product",
																"rules"=>"number"
															),
                                  );
                // load validation classs and pass validation data
                $dataValid = $this->loadValidation($validationArray)->formValidate();
                // check if the data is ok
                if(is_array($dataValid) && array_key_exists("success",$dataValid))
                {
                	//check product english name is exist
					if(TRUE !== $this->loadModel("ProductEnModel")->CheckExists("WHERE `name` =? AND  `deleted`=?",array($dataValid['success']['name'],1)))
					{
						// check product arabic name is exist before
						if(TRUE !== $this->loadModel("ProductArModel")->CheckExists("WHERE `name` =? AND  `deleted`=?",array($dataValid['success']['ar_name'],1)))
						{
							// start upload image
							$upload = $this->loadUpload("image")->do_upload();
							//if there is no errors
							if (!array_key_exists('uploadError', $upload))
							{
								// prepare data
								$dataModel['created_by'] = $user_id;
								$dataModel['last_updated_by'] = $user_id;
								$dataModel['special']=isset($dataValid['success']['special'])?1:2;
								$dataModel['id_category'] = $dataValid['success']['id_category'];
								$dataModel['status'] = $dataValid['success']['status'];
								$dataModel['image'] = $upload['uploaded'][0];
								$dataModel['created'] = time();
								$add = $this->loadModel("ProductModel",$dataModel)->add();
								if(FALSE !== $add)
								{
									// preparing en data
									$dataEnModel['created'] = time();
									$dataEnModel['id_product'] = $add;
									$dataEnModel['name'] = $dataValid['success']['name'];
									$dataEnModel['description'] = $dataValid['success']['description'];
									$dataEnModel['keywords'] = $dataValid['success']['keywords'];
									$dataEnModel['created_by']=$user_id;
									$dataEnModel['last_updated_by']=$user_id;
									$addEnData = $this->loadModel("ProductEnModel",$dataEnModel)->add();
									// preparing ar data
									$dataArModel['created'] = time();
									$dataArModel['id_product'] = $add;
									$dataArModel['name'] = $dataValid['success']['ar_name'];
									$dataArModel['description'] = $dataValid['success']['ar_description'];
									$dataArModel['keywords'] = $dataValid['success']['ar_keywords'];
									$dataArModel['created_by']=$user_id;
									$dataArModel['last_updated_by']=$user_id;
									$addArData = $this->loadModel("ProductArModel",$dataArModel)->add();
									if(False !== $addEnData && FALSE !== $addArData)
									{
										$dataView['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Data Added Successfully Please Wait .. </div>';
										header("Refresh: 2");
									}else{
										$dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Adding Your Data Please Try Again</div>';
									}
								}else{
									$dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Adding Your Data Please Try Again</div>';
								}

							}else{
								$dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Product Image Is Required (Max Image Size 2MB)</div>';
							}

						}else{
							$dataView['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Product Arabic Name Exists Before </div>';
						}

					}else{
						$dataView['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Product English Name  Exists Before </div>';
					}
                }else{
                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                }
            }
            // get main categories
            $dataView['categories'] = $this->loadModel('CategoryModel')->retrieveAllData("WHERE `id_category` IS NULL AND `status` =? AND `deleted` =?",array(1,1));
            if(is_array($dataView['categories']))
            {
                // get cateogy data And sub categories
                foreach($dataView['categories'] as $key=>$category)
                {
                    $dataView['categoryEn'][$key] = $this->loadModel("CategoryEnModel")->retriveDataById("id_category",$category['id']);
                    $dataView['categoryAr'][$key] = $this->loadModel("CategoryArModel")->retriveDataById("id_category",$category['id']);
                }
            }
            
			$dataView['title'] = "Add New Product";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
			$TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "product" . DIRECTORY_SEPARATOR . "product_add";

			// load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        
        public function getAll()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("error","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            
            // get all product
            $dataView['products'] = $this->loadModel("ProductModel")->retrieveAllData("WHERE `deleted` =?",array(1));
            if(is_array($dataView['products']))
            {
                foreach($dataView['products'] as $key=>$value)
                {
                    // get ar and en Data
                    $dataView['productEn'][$key] = $this->loadModel("ProductEnModel")->retriveDataById("id_product",$value['id']);
                    $dataView['productAr'][$key] = $this->loadModel("ProductArModel")->retriveDataById("id_product",$value['id']);
                    // get categories
                    $dataView['categoriesEn'][$key] = $this->loadModel("CategoryEnModel")->retriveDataById("id_category",$value['id_category']);
                    $dataView['categoriesAr'][$key] = $this->loadModel("CategoryArModel")->retriveDataById("id_category",$value['id_category']);
                }
            }
            
			$dataView['title'] = "Show / Edit Product";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
			$TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "product" . DIRECTORY_SEPARATOR . "product_getall";
			// load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        public function show_selected()
		{
			/******** start header code ********/
			if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
			{
				// get user id from session
				$user_id = $this->loadSession()->getSession("user_id");
				// get user data for header
				$dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
				if($dataView['userData'] == NULL)
				{
					$this->redirect("error","index");
					exit();
				}
			}else{
				$this->redirect("admin","login");
			}

			/******* end header code *******/
			//get id from url
			$id=$this->loadRoute()->getSegment(2);
			if($id==0)
			{
				$this->redirect("error","index");
				exit();
			}
			// get product data
			$dataView['product']=$this->loadModel("ProductModel")->retriveDataById('id',$id);
			if($dataView['product']==null)
			{
				$this->redirect("error","index");
				exit();
			}
			// get product info from ar and eng model
			if(is_array($dataView['product']))
			{
				$dataView['ar_product']=$this->loadModel("ProductArModel")->retriveDataById('id_product',$id);
				$dataView['en_product']=$this->loadModel("ProductEnModel")->retriveDataById('id_product',$id);
				//get categories
				$dataView['categoriesEn'] = $this->loadModel("CategoryEnModel")->retriveDataById("id_category",$dataView['product']['id_category']);
				$dataView['categoriesAr'] = $this->loadModel("CategoryArModel")->retriveDataById("id_category",$dataView['product']['id_category']);
				$dataView['createdBy']=$this->loadModel("UserModel")->retriveDataById('id',$dataView['product']['created_by']);
			}

			$dataView['title'] = "Show /Selected Product";
			// global Template Config
			global $TEMPLATE_BACK_END ;
			// set content
			$TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "product" . DIRECTORY_SEPARATOR . "product_show_selected";
			// load template
			$this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();

		}
        
        public function edit_selected()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("error","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            // get id from url
            $id = (int)$this->loadRoute()->getSegment(2);
            if($id == 0)
            {
                $this->redirect("error","index");
                exit();
            }
            // get data
            $dataView['product'] = $this->loadModel("ProductModel")->retrieveAllData("WHERE `id` =? AND `deleted` =?",array($id,1));
            if($dataView['product'] == NULL)
            {
                $this->redirect("error","index");
                exit();
            }
            $dataView['product'] = array_shift($dataView['product']);
             // get ar and en Data
            $dataView['prodEn'] = $this->loadModel("ProductEnModel")->retriveDataById("id_product",$id);
            $dataView['prodAr'] = $this->loadModel("ProductArModel")->retriveDataById("id_product",$id);

            //start Edit Brand
			if(isset($_POST['edit']))
            {
                
                // preparing validation array
                $validationArray = array(
											"id_category"=>array(
												"value"=>$this->loadSecurity($_POST['id_category'])->clear(),
												"errorName"=>"Category",
												"rules"=>"required|number"
											),
											"name"=>array(
												"value"=>$this->loadSecurity($_POST['enName'])->clear(),
												"errorName"=>"Product Name",
												"rules"=>"required|min-length[3]"
											),
											"ar_name"=>array(
												"value"=>$this->loadSecurity($_POST['arName'])->clear(),
												"errorName"=>"اسم المنتج",
												"rules"=>"required|min-length[3]"
											),
											"description"=>array(
												"value"=>$this->loadSecurity($_POST['en_description'])->clear(),
												"errorName"=>" Description",
												"rules"=>"required|min-length[3]"
											),
											"ar_description"=>array(
												"value"=>$this->loadSecurity($_POST['ar_description'])->clear(),
												"errorName"=>"وصف المنتج",
												"rules"=>"required|min-length[3]"
											),
											"keywords"=>array(
												"value"=>$this->loadSecurity($_POST['en_keywords'])->clear(),
												"errorName"=>"حقخيعؤف keywords",
												"rules"=>"required|min-length[3]"
											),
											"ar_keywords"=>array(
												"value"=>$this->loadSecurity($_POST['ar_keywords'])->clear(),
												"errorName"=>"الكلمات الدليلية",
												"rules"=>"required|min-length[3]"
											),
											"status"=>array(
												"value"=>$this->loadSecurity($_POST['status'])->clear(),
												"errorName"=>"Status",
												"rules"=>"number"
											),
                                  );
                // load validation classs and pass validation data
                $dataValid = $this->loadValidation($validationArray)->formValidate();
                // check if the data is ok
                if(is_array($dataValid) && array_key_exists("success",$dataValid))
                {
                	//check english name
					if(TRUE !== $this->loadModel("ProductEnModel")->CheckExists("WHERE `name` =? AND `id` !=? AND `deleted`=?",array($dataValid['success']['name'],$id,1)))
					{
						//check Arabic name
						if(TRUE !== $this->loadModel("ProductEnModel")->CheckExists("WHERE `name` =? AND `id` !=? AND `deleted`=?",array($dataValid['success']['ar_name'],$id,1)))
						{
							// prepare data
							$dataModel['last_updated_by'] = $user_id;
							$dataModel['id_category'] = $dataValid['success']['id_category'];
							$dataModel['status'] = $dataValid['success']['status'];
							$dataModel['created']=time();
							$updateData = $this->loadModel("ProductModel",$dataModel)->UpdateData("id",$id);
							if(FALSE !== $updateData)
							{
								// preparing en data
								$dataEnModel['name'] = $dataValid['success']['ar_name'];
								$dataEnModel['description'] = $dataValid['success']['ar_description'];
								$dataEnModel['keywords'] = $dataValid['success']['ar_keywords'];
								$dataEnModel['last_updated_by']=$user_id;
								$dataEnModel['created']=time();
								$updateEnData = $this->loadModel("ProductEnModel",$dataEnModel)->UpdateData("id_product",$id);
								// preparing ar data
								$dataArModel['name'] = $dataValid['success']['ar_name'];
								$dataArModel['description'] = $dataValid['success']['ar_description'];
								$dataArModel['keywords'] = $dataValid['success']['ar_keywords'];
								$dataArModel['last_updated_by']=$user_id;
								$dataArModel['created']=time();
								$updateArData = $this->loadModel("ProductArModel",$dataArModel)->UpdateData("id_product",$id);
								if(False !== $updateEnData && FALSE !== $updateArData)
								{
									$dataView['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Data Updated Successfully Please Wait .. </div>';
									header("Refresh: 2");
								}else{
									$dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Updating Your Data Please Try Again</div>';
								}
							}else{
								$dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Updating Your Data Please Try Again</div>';
							}
						}else{
							$dataView['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Product Arabic Name  Exists Before </div>';
						}

					}else{
						$dataView['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Product English Name  Exists Before </div>';
					}
                }else{
                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                }
            }
            
            // get main categories
            $dataView['categories'] = $this->loadModel('CategoryModel')->retrieveAllData("WHERE `id_category` IS NULL AND `status` =? AND `deleted` =?",array(1,1));
            if(is_array($dataView['categories']))
            {
                // get cateogy data And sub categories
                foreach($dataView['categories'] as $key=>$category)
                {
                    $dataView['categoryEn'][$key] = $this->loadModel("CategoryEnModel")->retriveDataById("id_category",$category['id']);
                    $dataView['categoryAr'][$key] = $this->loadModel("CategoryArModel")->retriveDataById("id_category",$category['id']);
                }
            }
			$dataView['title'] = "Edit Selected Product";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
			$TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "product" . DIRECTORY_SEPARATOR . "product_edit_selected";

			// load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        
        public function update_image()
        {
                //get id
                $id = (int)$_POST['field_id'];
                 if($id == 0)
                {
                    echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                    exit;
                }else{
                        $upload = $this->loadUpload("image_name")->do_upload();
                       // check if there is error on image
                       if(array_key_exists("uploadError",$upload))
                       {
                           echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                            exit;

                       }else{
                           // get user id from session
                           $user_id = $this->loadSession()->getSession("user_id");
                           $dataModel['last_updated_by'] = $user_id;
                           $dataModel['image'] = $upload['uploaded'][0];
                           if(false !== $this->loadModel("ProductModel",$dataModel)->updateData("id", $id))
                           {
                               echo $this->loadAjax()->DataToJson(array("status"=>"success","newImage"=>$dataModel['image']));
                                exit; 
                           }else{
                              echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                            exit;
                           }
                       }
                    }  
        }
        public function updateStatus()
        {
                if(isset($_POST['action'],$_POST['id'],$_POST['status']) && $_POST['action'] == "updateStatus")
                {
                    // get User id
                    $id = (int)$_POST['id'];
                    if($id == 0)
                    {
                        $this->redirect("error","index");
                        exit;
                    }else{
                        // get current status
                        $currentStatus = $_POST['status'];
                        // if current status = on set it off
                        if($currentStatus == "on")
                        {
                            $setStatus = 2;
                        }else{
                            $setStatus = 1;
                        }
                        // get user id from session
                        $user_id = $this->loadSession()->getSession("user_id");
                        $dataModel['last_updated_by'] = $user_id;
                        $dataModel['status'] = $setStatus;
                        if(false !== $this->loadModel("ProductModel",$dataModel)->updateData("id", $id))
                        {
							$this->loadModel("ProductEnModel",$dataModel)->updateData("id_product",$id);
							$this->loadModel("ProductArModel",$dataModel)->updateData("id_product",$id);

							echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                         exit;
                        }else{
                            echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                            exit;
                        }
                    }
                }
         }
        
        public function delete()
        {
                if(isset($_POST['action'],$_POST['id']) && $_POST['action'] == "deleteData")
                {
                    $id = (int)$_POST['id'];
                    if($id == 0)
                    {
                        $this->redirect("error","index");
                        exit;
                    }else{
                        // get user id from session
                        $user_id = $this->loadSession()->getSession("user_id");
                        $dataModel['last_updated_by'] = $user_id;
                        $dataModel['deleted'] = 2;
                        if(FALSE !== $this->loadModel("ProductModel",$dataModel)->updateData("id",$id))
                        {
							$this->loadModel("ProductEnModel",$dataModel)->updateData("id_product",$id);
							$this->loadModel("ProductArModel",$dataModel)->updateData("id_product",$id);
							echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                            exit;
                        }else{
                            echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                            exit;
                        }
                    }
                 }
         }
        
        
    }

?>