<?php
    class ServiceRequest extends Controller{
		
        public function GetTodayServiceRequest()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }
            /******* end header code *******/
            //define date
			$today = date('Y/m/d');
			//get service request data
			$dataView['serviceRequest']=$this->loadModel("ServiceRequestModel")->retrieveAllData("WHERE `created` >=? AND `deleted` =?",array(strtotime($today),1));
			if(is_array($dataView['serviceRequest']))
			{
				//get customer data
				foreach ($dataView['serviceRequest'] as $key=>$value):
					$dataView['requested_customer'][$key]=$this->loadModel("UserModel")->retriveDataById('id',$value['id_customer']);
					//get  arabic and english service data
					$dataView['serviceArTitle'][$key]=$this->loadModel("ServiceArModel")->retriveDataById('id_service',$value['id_service']);
					$dataView['serviceEnTitle'][$key]=$this->loadModel("ServiceEnModel")->retriveDataById('id_service',$value['id_service']);
				    $dataView['userAddress'][$key] = $this->loadModel("UserAddressModel")->retriveDataById('id',$value['id_address']);
                    $dataView['city'][$key] = $this->loadModel("CityEnModel")->retriveDataById('id_city',$dataView['userAddress'][$key]['id_city']);
	
                endforeach;
			}
            $dataView['title'] = "Show Today Service Request";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
			$TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "service_request" . DIRECTORY_SEPARATOR . "service_request_today_getall";
			// load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        public function GetMonthlyServiceRequest()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);

                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
			//define date
			//$monthDate = date('Y/m/01');

			$MonthlyOrders=date('Y/m/01');
			// get all service request during month
			$dataView['serviceRequest']=$this->loadModel("ServiceRequestModel")->retrieveAllData("WHERE `created` >=? AND `deleted` =?",array(strtotime($MonthlyOrders),1));
			if(is_array($dataView['serviceRequest']))
			{
				//get customer data
				foreach ($dataView['serviceRequest'] as $key=>$value):
					$dataView['requested_customer'][$key]=$this->loadModel("UserModel")->retriveDataById('id',$value['id_customer']);
					//get  arabic and english service data
					$dataView['serviceArTitle'][$key]=$this->loadModel("ServiceArModel")->retriveDataById('id_service',$value['id_service']);
					$dataView['serviceEnTitle'][$key]=$this->loadModel("ServiceEnModel")->retriveDataById('id_service',$value['id_service']);
				    $dataView['userAddress'][$key] = $this->loadModel("UserAddressModel")->retriveDataById('id',$value['id_address']);
                    $dataView['city'][$key] = $this->loadModel("CityEnModel")->retriveDataById('id_city',$dataView['userAddress'][$key]['id_city']);
	
                endforeach;
			}
            $dataView['title'] = "Show Monthly Service Request";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
			$TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "service_request" . DIRECTORY_SEPARATOR . "service_request_month_getall";
			// load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        public function GetReport()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/

            if(isset($_POST['search']))
            {
						// prpare adat for validation
						$validation_array = array(
											"date_from"=>array(
												"value"=>$this->loadSecurity($_POST['dateFrom'])->clear(),
												"errorName"=>"Date From",
												"rules"=>"required"
											),
											"date_to"=>array(
												"value"=>$this->loadSecurity($_POST['dateTo'])->clear(),
												"errorName"=>"Date To",
												"rules"=>"required"
											),
						);

						//start validation proccess
				$dataAfterValidation=$this->loadValidation($validation_array)->formValidate();
				// check data valid or not valid
				if(is_array($dataAfterValidation) && array_key_exists("success",$dataAfterValidation))
				{
					// get all service request
					$dataView['serviceRequest']=$this->loadModel("ServiceRequestModel")->retrieveAllData("WHERE `created` BETWEEN ? AND ? AND `deleted` =?",array(strtotime($dataAfterValidation['success']['date_from']),strtotime($dataAfterValidation['success']['date_to']),1));
					if(is_array($dataView['serviceRequest']))
					{
						//get customer data
						foreach ($dataView['serviceRequest'] as $key=>$value):
							$dataView['requested_customer'][$key]=$this->loadModel("UserModel")->retriveDataById('id',$value['id_customer']);
							//get  arabic and english service data
							$dataView['serviceArTitle'][$key]=$this->loadModel("ServiceArModel")->retriveDataById('id_service',$value['id_service']);
							$dataView['serviceEnTitle'][$key]=$this->loadModel("ServiceEnModel")->retriveDataById('id_service',$value['id_service']);
						    $dataView['userAddress'][$key] = $this->loadModel("UserAddressModel")->retriveDataById('id',$value['id_address']);
                            $dataView['city'][$key] = $this->loadModel("CityEnModel")->retriveDataById('id_city',$dataView['userAddress'][$key]['id_city']);
	
                        endforeach;
					}
				}else{
					$dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataAfterValidation.'</div>';
				}
			}
            $dataView['title'] = "Make Service Request Report";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
			$TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "service_request" . DIRECTORY_SEPARATOR . "service_request_report";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
		public function updateStatus()
		{
			if(isset($_POST['action'],$_POST['id'],$_POST['status']) && $_POST['action'] == "updateStatus")
			{
				// get User id
				$id = (int)$_POST['id'];
				if($id == 0)
				{
					$this->redirect("Errors","index");
					exit;
				}else{
					// get current status
					$currentStatus = $_POST['status'];
					// if current status = on set it off
					if($currentStatus == "on")
					{
						$setStatus = 2;
					}else{
						$setStatus = 1;
					}
					$dataModel['status'] = $setStatus;

					if(false !== $this->loadModel("ServiceRequestModel",$dataModel)->updateData("id", $id))
					{
						echo $this->loadAjax()->DataToJson(array("status"=>"success"));
						exit;
					}else{
						echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
						exit;
					}
				}
			}
		}
		public function getCutomerService()
		{
			/******** start header code ********/
			if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
			{
				// get user id from session
				$user_id = $this->loadSession()->getSession("user_id");
				// get user data for header
				$dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
				if($dataView['userData'] == NULL)
				{
					$this->redirect("Errors","index");
					exit();
				}
			}else{
				$this->redirect("admin","login");
			}
			//get customer id from url
			$customerId=$this->loadRoute()->getSegment(2);
			//validate cistomer id
			if($customerId == 0)
			{
				$this->redirect("Errors","index");
				exit();
			}
				//check customer data
			$dataView['customerData']=$this->loadModel("UserModel")->retriveDataById('id',$customerId);
			if($dataView['customerData']==null)
			{
				$this->redirect("Errors","index");
				exit();
			}
			//get service request data
			$dataView['serviceRequest']=$this->loadModel("ServiceRequestModel")->retrieveAllData("WHERE `id_customer`=? AND `deleted` =? ORDER BY id DESC",array($customerId,1));
			$dataView['serviceCount']=count($dataView['serviceRequest']);
			if(is_array($dataView['serviceRequest']))
			{
				//get customer data
				foreach ($dataView['serviceRequest'] as $key=>$value):
					$dataView['requested_customer'][$key]=$this->loadModel("UserModel")->retriveDataById('id',$value['id_customer']);
					//get  arabic and english service data
					$dataView['serviceArTitle'][$key]=$this->loadModel("ServiceArModel")->retriveDataById('id_service',$value['id_service']);
					$dataView['serviceEnTitle'][$key]=$this->loadModel("ServiceEnModel")->retriveDataById('id_service',$value['id_service']);
				endforeach;
			}

			/******* end header code *******/
			$dataView['title'] = "Customer Service Request";
			// global Template Config
			global $TEMPLATE_BACK_END ;
			// set content
			$TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "service_request" . DIRECTORY_SEPARATOR . "service_request_customer";
			// load template
			$this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
		}



    }

?>