<?php
	class VendorProduct extends Controller{

        
        public function add()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/

			//get id from url
			$priductId=$this->loadRoute()->getSegment(2);
			//validate id
			if($priductId ==0){
				$this->redirect("Errors","index");
				exit();
			}
			//get product id info
			$dataView['product']=$this->loadModel("OfferModel")->retriveDataById('id',$priductId);
			if($dataView['product'] == null)
			{
				$this->redirect("Errors","index");
				exit();
			}
			// start add process
			if(isset($_POST['add']))
			{


				//prepare data for validation
				$validation_array=array(
											"price_per_item"=>array(
												"value"=>$this->loadSecurity($_POST['price_per_item'])->clear(),
												"errorName"=>"Product Price",
												"rules"=>"required|number"
											),
											"quantity"=>array(
												"value"=>$this->loadSecurity($_POST['quantity'])->clear(),
												"errorName"=>"Quantity",
												"rules"=>"required|number"
											),

						               );
				//check data valid or not
				$dataAfterValidation=$this->loadValidation($validation_array)->formValidate();
				if(is_array($dataAfterValidation)&&array_key_exists("success",$dataAfterValidation))
				{
			 	$user_id = $this->loadSession()->getSession("user_id");
					// check this product and vendor exist befour or not
					if(TRUE == $this->loadModel("VendorHasProductModel")->CheckExists("WHERE `id_product` =? AND `id_vendor`=? AND  `deleted`=?",array($priductId,$user_id,1)))
					{
						$update=$this->loadModel("VendorHasProductModel")->retrieveDataByQuery("UPDATE `vendor_has_product` SET `quantity_added` = `quantity_added` +? WHERE `id_product`=? AND `id_vendor`=? ",array($dataAfterValidation['success']['quantity'],$priductId,$user_id));
						if(false !==$update)
						{
							$dataTovendorModelDetails['id_product']=$priductId;
							$dataTovendorModelDetails['price_per_item']=$dataAfterValidation['success']['price_per_item'];
							$dataTovendorModelDetails['quantity']=$dataAfterValidation['success']['quantity'];
							$dataTovendorModelDetails['created']=time();
							$dataTovendorModelDetails['last_updated_by']=$user_id;
							$dataTovendorModelDetails['id_vendor']=$user_id;
							$dataTovendorModelDetails['created_by']=$user_id;
							$adddetails=$this->loadModel("VendorAppendPproductQuantityModel",$dataTovendorModelDetails)->add();
							if(false!==$adddetails)
							{
								$dataView['message'] = '<div class="alert alert-success" role="alert"><strong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Data Adding Successfully Please Wait .. </div>';
								header("Refresh: 2");
							}else{
								$dataView['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Adding Your Data </div>';
							}
						}else{
							$dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Adding Your Data </div>';
						}
					}else{
						// prepare to add data
						$dataTovendorModel['id_product']=$priductId;
						$dataTovendorModel['price_per_item']=$dataAfterValidation['success']['price_per_item'];
						$dataTovendorModel['quantity_added']=$dataAfterValidation['success']['quantity'];
						$dataTovendorModel['created']=time();
						$dataTovendorModel['last_updated_by']=$user_id;
						$dataTovendorModel['id_vendor']=$user_id;
						$dataTovendorModel['created_by']=$user_id;
						$add=$this->loadModel("VendorHasProductModel",$dataTovendorModel)->add();
						if(false !==$add)
						{
							$dataTovendorModelDetails['id_product']=$priductId;
							$dataTovendorModelDetails['price_per_item']=$dataAfterValidation['success']['price_per_item'];
							$dataTovendorModelDetails['quantity']=$dataAfterValidation['success']['quantity'];
							$dataTovendorModelDetails['created']=time();
							$dataTovendorModelDetails['last_updated_by']=$user_id;
							$dataTovendorModelDetails['id_vendor']=$user_id;
							$dataTovendorModelDetails['created_by']=$user_id;

							$adddetails=$this->loadModel("VendorAppendPproductQuantityModel",$dataTovendorModelDetails)->add();
							$dataView['message'] = '<div class="alert alert-success" role="alert"><strong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Data Adding Successfully Please Wait .. </div>';
							header("Refresh: 2");
						}else{
							$dataView['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Adding Your Data </div>';
						}
					}
				}else{
					$dataView['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataAfterValidation.'</div>';
				}
			}

			$dataView['title'] = "Add Vendor Product";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "vendor_product" . DIRECTORY_SEPARATOR ."vendor_product_add";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }

		public function showVendorOffer()
		{
			/******** start header code ********/
			if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
			{
				// get user id from session
				$user_id = $this->loadSession()->getSession("user_id");
				// get user data for header
				$dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
				if($dataView['userData'] == NULL)
				{
					$this->redirect("Errors","index");
					exit();
				}
			}else{
				$this->redirect("admin","login");
			}

			/******* end header code *******/

			//get id from url
			$priductId=$this->loadRoute()->getSegment(2);
			//validate id
			if($priductId ==0){
				$this->redirect("Errors","index");
				exit();
			}
			//get product id info
			$dataView['product']=$this->loadModel("OfferModel")->retriveDataById('id',$priductId);
			if($dataView['product'] == null)
			{
				$this->redirect("Errors","index");
				exit();
			}
			$dataView['vendorProduct']=$this->loadModel("VendorAppendPproductQuantityModel")->retrieveAllData("WHERE `id_product`=? AND `deleted`=?   group  by Id_vendor",array($priductId,1));
			//get all data to show
			if(is_array($dataView['vendorProduct']))
			{
				foreach ($dataView['vendorProduct'] as $key=>$value)
				{
						$dataView['vendor'][$key]=$this->loadHelper("getLastId")->CheckId($value['id_vendor']);
					// get create user
					$dataView['created'][$key]=$this->loadModel("UserModel")->retriveDataById('id',$value['created_by']);
					$dataView['vindor'][$key]=$this->loadModel("UserModel")->retriveDataById('id',$value['id_vendor']);

				}
			}
			//var_dump($dataView['vendor']);
//select * from vendor_append_product_quantity where id_product=5 GROUP by id DESC limit 1
			$dataView['title'] = "Vendor Offer";
			// global Template Config
			global $TEMPLATE_BACK_END ;
			// set content
			$TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "vendor_product" . DIRECTORY_SEPARATOR ."vendor_product";
			// load template
			$this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
		}


        
        public function getAll()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            
            // get all counteries
            $dataView['counteries'] = $this->loadModel("CountryModel")->retrieveAllData("WHERE `deleted` =?",array(1));
            if(is_array($dataView['counteries']))
            {
                foreach($dataView['counteries'] as $key=>$value)
                {
                    // get ar and en data
                    $dataView['counteriesEn'][$key] = $this->loadModel("CountryEnModel")->retriveDataById("id_country",$value['id']);
                    $dataView['counteriesAr'][$key] = $this->loadModel("CountryArModel")->retriveDataById("id_country",$value['id']);
                
                    // get last updated by and created by
                    $dataView['createdBy'][$key] = $this->loadModel("UserModel")->retriveDataById("id",$value['created_by']);
                    $dataView['lastUpdateBy'][$key] = $this->loadModel("UserModel")->retriveDataById("id",$value['last_updated_by']);
                }
            }
            
			$dataView['title'] = "Show / Edit Country";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "country" . DIRECTORY_SEPARATOR ."country_getall";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        
        public function edit_selected()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            // get id from url
            $id = (int)$this->loadRoute()->getSegment(2);
            if($id == 0)
            {
                $this->redirect("Errors","index");
                exit();
            }
            // get data
            $dataView['country'] = $this->loadModel("CountryModel")->retrieveAllData("WHERE `id` =? AND `deleted` =?",array($id,1));
            if($dataView['country'] == NULL)
            {
                $this->redirect("Errors","index");
                exit();
            }
            $dataView['country'] = array_shift($dataView['country']);
             // get ar and en Data
            $dataView['countryEn'] = $this->loadModel("CountryEnModel")->retriveDataById("id_country",$id);
            $dataView['countryAr'] = $this->loadModel("CountryArModel")->retriveDataById("id_country",$id);

             // start edit country
			if(isset($_POST['edit']))
            {
                // preparing validation array
                // preparing validation array
                $validationArray = array(
                                            "name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['name'])->clear(),
                                                             "errorName"=>"Country Name",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "shortcut_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['shortcut_name'])->clear(),
                                                             "errorName"=>"Shortcut Name",
                                                             "rules"=>"required|min-length[1]"
                                                          ),
                                            "currency_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['currency'])->clear(),
                                                             "errorName"=>"Country Currency",
                                                             "rules"=>"required|min-length[2]"
                                                          ),
                                            "currency_shortcut_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['shortcut_currency'])->clear(),
                                                             "errorName"=>"Country Currency Shortcut",
                                                             "rules"=>"required|min-length[1]"
                                                          ),
                                            
                                            "phone_key"=>array(
                                                             "value"=>$this->loadSecurity($_POST['phone_key'])->clear(),
                                                             "errorName"=>"Country Currency Phone Key",
                                                             "rules"=>"required|min-length[1]"
                                                          ),
                                            "longitude"=>array(
                                                             "value"=>$this->loadSecurity($_POST['long'])->clear(),
                                                             "errorName"=>"Country Longitude",
                                                             "rules"=>"required"
                                                          ),
                                            "latitude"=>array(
                                                             "value"=>$this->loadSecurity($_POST['lat'])->clear(),
                                                             "errorName"=>"Country Latitude",
                                                             "rules"=>"required"
                                                          ),
                                            "ar_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['ar_name'])->clear(),
                                                             "errorName"=>"أسم الدولة",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "ar_shortcut_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['ar_shortcut_name'])->clear(),
                                                             "errorName"=>"مختصر الاسم",
                                                             "rules"=>"required|min-length[1]"
                                                          ),
                                            "ar_currency_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['ar_currency'])->clear(),
                                                             "errorName"=>"اسم العملة",
                                                             "rules"=>"required|min-length[2]"
                                                          ),
                                            "ar_currency_shortcut_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['ar_shortcut_currency'])->clear(),
                                                             "errorName"=>"مختصر العملة",
                                                             "rules"=>"required|min-length[1]"
                                                          ),
                                            "status"=>array(
                                                             "value"=>$this->loadSecurity($_POST['status'])->clear(),
                                                             "errorName"=>"Status",
                                                             "rules"=>"number"
                                                          ),
                                  );
                // load validation classs and pass validation data
                $dataValid = $this->loadValidation($validationArray)->formValidate();
                // check if the data is ok
                if(is_array($dataValid) && array_key_exists("success",$dataValid))
                {
                    //check if country En Name exists before
                    if(TRUE !== $this->loadModel("CountryEnModel")->CheckExists("WHERE `name` =? AND `id_country` != ? AND `deleted`=?",array($dataValid['success']['name'],$id,1)))
                    {
                        //check if country En Name exists before
                        if(TRUE !== $this->loadModel("CountryArModel")->CheckExists("WHERE `name` =? AND `id_country` != ? AND `deleted`=?",array($dataValid['success']['name'],$id,1)))
                        {
                            // prepare data
                            $dataModel['phone_key'] = $dataValid['success']['phone_key'];
                            $dataModel['longitude'] = $dataValid['success']['longitude'];
                            $dataModel['latitude'] = $dataValid['success']['latitude'];
                            $dataModel['last_updated_by'] = $user_id;
                            $dataModel['status'] = $dataValid['success']['status'];
                            $updateData = $this->loadModel("CountryModel",$dataModel)->updateData("id",$id);
                            if(FALSE !== $updateData)
                            {
                               // preparing ar data
                                $dataArModel['name'] = $dataValid['success']['ar_name'];
                                $dataArModel['shortcut_name'] = $dataValid['success']['ar_shortcut_name'];
                                $dataArModel['currency_name'] = $dataValid['success']['ar_currency_name'];
                                $dataArModel['currency_shortcut_name'] = $dataValid['success']['ar_currency_shortcut_name'];
                                $dataArModel['last_updated_by'] = $user_id;
                                $dataArModel['status'] = $dataValid['success']['status'];
                                $updateArData = $this->loadModel("CountryArModel",$dataArModel)->updateData("id_country",$id);

                                // preparing  en data
                                $dataEnModel['name'] = $dataValid['success']['name'];
                                $dataEnModel['shortcut_name'] = $dataValid['success']['shortcut_name'];
                                $dataEnModel['currency_name'] = $dataValid['success']['currency_name'];
                                $dataEnModel['currency_shortcut_name'] = $dataValid['success']['currency_shortcut_name'];
                                $dataEnModel['last_updated_by'] = $user_id;
                                $dataEnModel['status'] = $dataValid['success']['status'];
                                $updateEnData = $this->loadModel("CountryEnModel",$dataEnModel)->updateData("id_country",$id);
                                if(False !== $updateEnData && FALSE !== $updateArData)
                                {
                                   $dataView['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Data Updated Successfully Please Wait .. </div>';
                                   header("Refresh: 2"); 
                                }else{
                                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Updating Some Data Please Try Again</div>';
                                }
                            }else{
                                $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Updating Your Data Please Try Again</div>';
                            }
                        }else{
                            $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Country Arabic Name Exists Before</div>';
                        }
                    }else{
                        $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Country English Name Exists Before</div>';
                    }
                }else{
                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                }
            }
            
            // set page title
			$dataView['title'] = "Edit Selected Country";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "country" . DIRECTORY_SEPARATOR ."country_edit_selected";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        public function update_image()
        {
                //get id
                $id = (int)$_POST['field_id'];
                 if($id == 0)
                {
                    echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                    exit;
                }else{
                        $upload = $this->loadUpload("image_name")->do_upload();
                       // check if there is error on image
                       if(array_key_exists("uploadError",$upload))
                       {
                           echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                            exit;

                       }else{
                           $dataModel['flag'] = $upload['uploaded'][0];
                           if(false !== $this->loadModel("CountryModel",$dataModel)->updateData("id", $id))
                           {
                               echo $this->loadAjax()->DataToJson(array("status"=>"success","newImage"=>$dataModel['flag']));
                                exit; 
                           }else{
                              echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                            exit;
                           }
                       }
                    }  
        }
        public function updateStatus()
        {
                if(isset($_POST['action'],$_POST['id'],$_POST['status']) && $_POST['action'] == "updateStatus")
                {
                    // get User id
                    $id = (int)$_POST['id'];
                    if($id == 0)
                    {
                        $this->redirect("Errors","index");
                        exit;
                    }else{
                        // get current status
                        $currentStatus = $_POST['status'];
                        // if current status = on set it off
                        if($currentStatus == "on")
                        {
                            $setStatus = 2;
                        }else{
                            $setStatus = 1;
                        }
                        $dataModel['status'] = $setStatus;
                        $dataModel['last_updated_by'] = $this->loadSession()->getSession("user_id");

                        if(false !== $this->loadModel("CountryModel",$dataModel)->updateData("id", $id))
                        {
                             $this->loadModel("CountryArModel",$dataModel)->updateData("id_country", $id);
                             $this->loadModel("CountryEnModel",$dataModel)->updateData("id_country", $id);
                             echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                             exit;
                        }else{
                            echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                            exit;
                        }
                    }
                }
         }

        
    }

?>